package UDP::Model::Distance;

use Moose;

has 'alpha' => ( is => 'rw', isa => 'Num', default => 2 );

sub initialize {
}

sub compute_counts_and_logprob {
    my ($self, $type, $node, $diff_count, $diff_logprob, $count) = @_;
    my $parent_ord = $node->parent->ord;
    my $distance = $parent_ord == 0 ? 10 : abs($parent_ord - $node->ord);
    if ($type eq 'del') {
        $$diff_logprob -= log(1/$distance**$self->alpha);
    }
    elsif ($type eq 'ins') {
        $$diff_logprob += log(1/$distance**$self->alpha);
    }
}

1;

