#!/usr/bin/perl

use strict;
use warnings;

my @parent;
my $uas = 0;
my $uuas = 0;
my $ned = 0;
my $total = 0;

open (GOLD, "<:utf8", $ARGV[0]) or die;
my $s = 0;
while (<GOLD>) {
    chomp;
    if (/^\d/) {
        my @item = split(/\t/, $_);
        $parent[$s][$item[0]] = $item[6];
    }
    else {
        $s++;
    }
}
close GOLD;

my $gold_sentences = $s;

open (OUTPUT, "<:utf8", $ARGV[1]) or die;
$s = 0;
while (<OUTPUT>) {
    chomp;
    if (/^\d/) {
        $total++;
        my @item = split(/\t/, $_);
        if ($item[6] == $parent[$s][$item[0]]) {
            $uas++;
            $uuas++;
            $ned++;
        }
        elsif ($item[6] && $item[0] == $parent[$s][$item[6]]) {
            $uuas++;
            $ned++;
        }
        elsif ($parent[$s][$item[0]] && $item[6] == $parent[$s][$parent[$s][$item[0]]]) {
            $ned++;
        }
    }
    else {
        $s++;
        last if $s >= $gold_sentences;
    }
}
close OUTPUT;

print "UAS: ".($uas*100/$total)."\tUUAS: ".($uuas*100/$total)."\tNED: ".($ned*100/$total)."\n";
